/*
 *   Copyright 2014-2023 IHE International
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, v2.2.4-2 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2012.12.25 at 01:02:08 PM CET 
//

package net.ihe.gazelle.audit.message.desc;

import org.jboss.seam.annotations.Name;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.*;
import java.io.Serializable;

/**
 * <p>
 * Java class for ElementDescription complex type.
 * 
 * <p>
 * The following schema fragment specifies the expected content contained within
 * this class.
 * 
 * <pre>
 * &lt;complexType name=&quot;ElementDescription&quot;&gt;
 *   &lt;complexContent&gt;
 *     &lt;restriction base=&quot;{http://www.w3.org/2001/XMLSchema}anyType&quot;&gt;
 *       &lt;attribute name=&quot;optionality&quot; type=&quot;{}Optionality&quot; default=&quot;NA&quot; /&gt;
 *       &lt;attribute name=&quot;value&quot; type=&quot;{http://www.w3.org/2001/XMLSchema}string&quot; /&gt;
 *       &lt;attribute name=&quot;regex&quot; type=&quot;{http://www.w3.org/2001/XMLSchema}string&quot; /&gt;
 *     &lt;/restriction&gt;
 *   &lt;/complexContent&gt;
 * &lt;/complexType&gt;
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ElementDescription")
@Entity
@Name("elementDescription")
@Table(name = "am_element_description", schema = "public")
@SequenceGenerator(name = "am_element_description_sequence", sequenceName = "am_element_description_id_seq", allocationSize = 1)
public class ElementDescription implements Serializable {

	private static final long serialVersionUID = 1L;

	@XmlTransient
	@Id
	@GeneratedValue(generator = "am_element_description_sequence", strategy = GenerationType.SEQUENCE)
	@NotNull
	@Column(name = "id")
	private Integer id;

	@XmlAttribute(name = "optionality")
	@Enumerated(EnumType.STRING)
	protected Optionality optionality;

	@XmlAttribute(name = "value")
	protected String value;

	@XmlAttribute(name = "regex")
	protected String regex;

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	/**
	 * Gets the value of the optionality property.
	 * 
	 * @return possible object is {@link Optionality }
	 * 
	 */
	public Optionality getOptionality() {
		if (optionality == null) {
			return Optionality.NA;
		} else {
			return optionality;
		}
	}

	/**
	 * Sets the value of the optionality property.
	 * 
	 * @param value
	 *            allowed object is {@link Optionality }
	 * 
	 */
	public void setOptionality(Optionality value) {
		this.optionality = value;
	}

	/**
	 * Gets the value of the value property.
	 * 
	 * @return possible object is {@link String }
	 * 
	 */
	public String getValue() {
		if ((value != null) && value.equals("")) {
			value = null;
		}
		return value;
	}

	/**
	 * Sets the value of the value property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setValue(String value) {
		if ((value != null) && value.equals("")) {
			value = null;
		}
		this.value = value;
	}

	/**
	 * Gets the value of the regex property.
	 * 
	 * @return possible object is {@link String }
	 * 
	 */
	public String getRegex() {
		if ((regex != null) && regex.equals("")) {
			regex = null;
		}
		return regex;
	}

	/**
	 * Sets the value of the regex property.
	 *
	 * @param val
	 *            allowed object is {@link String }
	 * 
	 */
	public void setRegex(String val) {
		if ((val != null) && val.equals("")) {
			val = null;
		}
		this.regex = val;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = (prime * result)
				+ ((optionality == null) ? 0 : optionality.hashCode());
		result = (prime * result) + ((regex == null) ? 0 : regex.hashCode());
		result = (prime * result) + ((value == null) ? 0 : value.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		ElementDescription other = (ElementDescription) obj;
		if (optionality != other.optionality) {
			return false;
		}
		if (regex == null) {
			if (other.regex != null) {
				return false;
			}
		} else if (!regex.equals(other.regex)) {
			return false;
		}
		if (value == null) {
			if (other.value != null) {
				return false;
			}
		} else if (!value.equals(other.value)) {
			return false;
		}
		return true;
	}

}
